/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: RSAUtil.java 9137 2006-09-27 01:41:57Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applications.signerclient.crypto.jce;

import java.security.interfaces.RSAPrivateCrtKey;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;

import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;

/**
 * @version $Rev: 9137 $ $Date: 2006-09-27 08:41:57 +0700 (Wed, 27 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
class RSAUtil {

//	public static boolean isRsaOid(DERObjectIdentifier algOid) {
//		return algOid.equals(PKCSObjectIdentifiers.rsaEncryption)
//		        || algOid.equals(X509ObjectIdentifiers.id_ea_rsa)
//		        || algOid.equals(PKCSObjectIdentifiers.id_RSASSA_PSS)
//		        || algOid.equals(PKCSObjectIdentifiers.id_RSAES_OAEP);
//	}

	public static RSAKeyParameters generatePublicKeyParameter(RSAPublicKey key) {
		return new RSAKeyParameters(false, key.getModulus(), key
		        .getPublicExponent());

	}

	public static RSAKeyParameters generatePrivateKeyParameter(RSAPrivateKey key) {
		if (key instanceof RSAPrivateCrtKey) {
			RSAPrivateCrtKey k = (RSAPrivateCrtKey) key;

			return new RSAPrivateCrtKeyParameters(k.getModulus(), k
			        .getPublicExponent(), k.getPrivateExponent(),
			        k.getPrimeP(), k.getPrimeQ(), k.getPrimeExponentP(), k
			                .getPrimeExponentQ(), k.getCrtCoefficient());
		} else {
			RSAPrivateKey k = key;

			return new RSAKeyParameters(true, k.getModulus(), k
			        .getPrivateExponent());
		}
	}
}
