/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: SignerUtil.java 9137 2006-09-27 01:41:57Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applications.signerclient.util;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

import org.exoplatform.applet.util.Base64Encoder;

/**
 * @version $Rev: 9137 $ $Date: 2006-09-27 08:41:57 +0700 (Wed, 27 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class SignerUtil {

	private static Base64Encoder encoder;

    private SignerUtil() {
	    super();
    }

    private static Base64Encoder getEncoder() {
    	if (encoder == null)
    		encoder = new Base64Encoder();
    	return encoder;
    }

    public static byte[] base64Decode(String data) {

    	Base64Encoder base64 = getEncoder();

    	ByteArrayOutputStream out = new ByteArrayOutputStream();
    	try {
	        base64.decode(data, out);
        } catch (IOException e) {
	        // do nothing
        }

    	return out.toByteArray();
    }

	/**
     * @param data
     * @return
     */
    public static String base64Encode(byte[] data) {

    	Base64Encoder base64 = getEncoder();

    	ByteArrayOutputStream out = new ByteArrayOutputStream();
    	try {
	        base64.encode(data, 0, data.length, out);
        } catch (IOException e) {
	        // do nothing
        }

    	return out.toString();
    }
}
