/*
 * Created on Apr 14, 2005
 */
package org.exoplatform.faces.cms;

import java.util.List;

import javax.jcr.Node;
import javax.jcr.Property;

import org.exoplatform.services.grammar.wiki.WikiContext;
import org.exoplatform.services.grammar.wiki.WikiEngineService;

/**
 * @author benjaminmestrallet
 */
public interface CMSViewComponent extends CMSDialogComponent{
  
  public String getPortalName();
  
  public String getWorkspaceName() throws Exception;
  
  public void setNode(Node node);
  
  public Object getComponentInstanceOfType(String className);
  
  public WikiContext getWikiContext();
  
  public WikiEngineService getWikiService();

  public String getNodeType() throws Exception;
  
  public boolean isNodeTypeSupported();
  
  public String getTemplatePath() throws Exception;
  
  public List<Node> getRelations() throws Exception;

  public List<Node> getAttachments() throws Exception;
  
  public String getAttachmentSize(Node node);
  
  public boolean hasPropertyContent(Node node, String property) ;
  
  public boolean isRssLink() ;
  
  public String getRssLink() ;
  
  public List getSupportedLocalise() throws Exception  ;  
  
  public String getSmallNodeTypeIcon(Node node) ;  
  
  public String getLargeNodeTypeIcon(Node node) ;
  
  public String getPropertyTypeIcon(Property property) ;
  
  public String getPropertyIconByName(String propertyName) ;
  
}
