/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.actions.component;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.nodetype.NodeType;

import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.jcr.component.ChangeNodeListener;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;
import org.exoplatform.services.cms.actions.ActionServiceContainer;


/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIContentDisplayer.java,v 1.2 2004/08/07 18:11:26 tuan08 Exp $
 */
public class UISelectActionForm extends UISimpleForm  implements ChangeNodeListener{
 
  final static public String CHANGE_ACTION = "change" ;
  
  UISelectBox uiSelect_ ;
  
  protected String defaultAction_;

  protected ActionServiceContainer actionsServiceContainer_;

  protected Node node_;  
  
  public UISelectActionForm(ActionServiceContainer actionsServiceContainer) throws Exception {
    super("selectActionForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer");
    
    uiSelect_ = new  UISelectBox("actionType", "", null) ;
    uiSelect_.setUpdateOnChangeAction(CHANGE_ACTION) ;
    add(uiSelect_) ;
    
    actionsServiceContainer_ = actionsServiceContainer;
    
    addActionListener(ChangeActionListener.class, CHANGE_ACTION) ;
  }  
  
  public void  onChange(UIJCRExplorer uiExplorer, Node node)  throws Exception {
    setRendered(false);
    node_ = node;
  }          
  
  private Iterator getCreatedActionTypes() throws Exception{
    return actionsServiceContainer_.getCreatedActionTypes().iterator();
  }
  
  public String getDefaultAction() throws Exception{    
    if(defaultAction_ == null) {
      Iterator actions = getCreatedActionTypes();
      defaultAction_ = ((NodeType) actions.next()).getName();
    }
    return defaultAction_;
  }  
  
  public void update() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    Iterator actions = getCreatedActionTypes();    
    while(actions.hasNext()){
      String action = ((NodeType) actions.next()).getName();
      options.add(new SelectItem(action, action));
    }    
    uiSelect_.setOptions(options) ;
    uiSelect_.setValue(getDefaultAction());
  }
  
  static public class ChangeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UISelectActionForm uicomp = (UISelectActionForm) event.getSource() ;
      String action = uicomp.uiSelect_.getValue() ;
      UIActionForm uiForm = (UIActionForm) uicomp.getSibling(UIActionForm.class) ;
      uiForm.createNewAction(uicomp.node_, action) ;
    }
  }

}