/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.contentbrowser.component;

import javax.portlet.PortletPreferences;

import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.cms.component.JcrBrowser;
import org.exoplatform.faces.core.component.UIPortlet;


/**
 * Created by The eXo Platform SARL
 * Author : HoaPham
 *          phamvuxuanhoa@yahoo.com
 * Jan 20, 2006
 */
public class UIContentBrowserConfig extends UIPortlet {        

  public UIContentBrowserConfig() throws Exception {    
    setId("ContentBrowserConfig") ;
    setRendererType("ChildrenRenderer");  
    
    JcrBrowser jcrBrowser = (JcrBrowser)addChild(JcrBrowser.class) ;
    jcrBrowser.setRendered(false) ;
    UIPathConfig pathConfig = (UIPathConfig)addChild(UIPathConfig.class) ;
    pathConfig.setRendered(false) ;    
    UIScriptConfig scriptConfig = (UIScriptConfig)addChild(UIScriptConfig.class) ;
    scriptConfig.setRendered(false) ;    
    UIQueryConfig queryConfig = (UIQueryConfig)addChild(UIQueryConfig.class) ;
    queryConfig.setRendered(false) ;    
    UIDocumentConfig documentConfig = (UIDocumentConfig)addChild(UIDocumentConfig.class) ;
    documentConfig.setRendered(false) ;   
    addChild(UINewConfigForm.class).setRendered(false) ;
    PortletPreferences prefs = FacesUtil.getPortletPreferences();
    String usecase_ = prefs.getValue(CBUtils.USECASE,"") ;
    if(usecase_.equals(CBUtils.FORM_PATH)) {
      pathConfig.updateFormValues() ;
      pathConfig.setEditable(false) ;      
      pathConfig.setRendered(true) ;      
    }else if (usecase_.equals(CBUtils.USE_JCR_QUERY)) {
      queryConfig.updateFormFields() ;
      queryConfig.setEditable(false) ;      
      queryConfig.setRendered(true) ;
    }else if ( usecase_.equals(CBUtils.USE_SCRIPT)) { 
      scriptConfig.updateFormValues() ;
      scriptConfig.setEditable(false) ;
      scriptConfig.setRendered(true) ;      
    }else if(usecase_.equals(CBUtils.USE_DOCUMENT)) {
      documentConfig.updateFormValues() ;
      documentConfig.setEditable(false) ;      
      documentConfig.setRendered(true) ;
    }
  }        

  public void saveBrowserConfig( String workspace, String jcrPath, String queryLanguage,
      String queryStatement, String isNewQuery, String isPersonalQuery, String queryStore, String nbPerPage, String template, String boxTemplate,
      String showRefDocument, String showChildDocument, 
      String viewToolbar, String usecase, String documentName,
      String scriptName,String viewTagsCloud,String allowVoting, String allowComment ) throws Exception {            

    PortletPreferences prefs = FacesUtil.getPortletPreferences();        
    prefs.setValue(CBUtils.WORKSPACE,workspace) ;
    prefs.setValue(CBUtils.JCR_PATH,jcrPath) ;
    prefs.setValue(CBUtils.QUERY_LANGUAGE,queryLanguage) ;
    prefs.setValue(CBUtils.QUERY_STATEMENT,queryStatement) ;
    prefs.setValue(CBUtils.IS_NEW_QUERY,isNewQuery) ;
    prefs.setValue(CBUtils.IS_PERSONAL_QUERY,isPersonalQuery) ;
    prefs.setValue(CBUtils.QUERY_STORE,queryStore) ;
    prefs.setValue(CBUtils.NB_PER_PAGE,nbPerPage) ;
    prefs.setValue(CBUtils.TEMPLATE,template) ;
    prefs.setValue(CBUtils.BOX_TEMPLATE,boxTemplate) ;    
    prefs.setValue(CBUtils.REF_DOCUMENT,showRefDocument) ;
    prefs.setValue(CBUtils.CHILD_DOCUMENT,showChildDocument) ;    
    prefs.setValue(CBUtils.VIEW_TOOLBAR,viewToolbar) ;    
    prefs.setValue(CBUtils.USECASE,usecase) ;
    prefs.setValue(CBUtils.DOCUMENT_NAME,documentName) ;
    prefs.setValue(CBUtils.SCRIPT_NAME, scriptName) ;
    prefs.setValue(CBUtils.VIEW_TAGS_CLOUD,viewTagsCloud) ;
    prefs.setValue(CBUtils.ALLOW_VOTING,allowVoting) ;
    prefs.setValue(CBUtils.ALLOW_COMMENT,allowComment) ;
    prefs.store() ;    
  }
}
