/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.folksonomy.component;

import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.Node;

import org.apache.commons.lang.StringUtils;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.component.ChangeNodeListener;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;
import org.exoplatform.services.cms.folksonomy.FolksonomyService;

/**
 * Created by The eXo Platform SAS
 * Author : Xuan Hoa Pham
 *          hoapham@exoplatform.com
 * 					phamvuxuanhoa@gmail.com
 * Dec 7, 2006  
 */
public class UITaggingForm extends UISimpleForm implements ChangeNodeListener {
  
  final static public String TAGGING_NAMES = "tagNames".intern() ;
  
  private UIStringInput tagNamesInput_ ;
  private Node document4Tagging_ ;  
  
  
  public UITaggingForm() {
    super("UITaggingForm", "post",null);
    setRendererType("SimpleFormVelocityRenderer");
    
    tagNamesInput_ = new UIStringInput(TAGGING_NAMES,"") ;
    add(tagNamesInput_) ;
    
    addActionListener(SaveActionListener.class,SAVE_ACTION) ;        
  }
  
  public Node getDocumentNode() { return document4Tagging_ ; }
  
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    document4Tagging_ = node ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UITaggingForm taggingForm = (UITaggingForm)event.getSource() ;
      UIStringInput tagNamesInput = taggingForm.getUIStringInput(UITaggingForm.TAGGING_NAMES) ;
      String names = tagNamesInput.getValue() ;
      String[] tagNames = StringUtils.split(names,";") ;      
      ResourceBundle res = getApplicationResourceBundle() ;
      Information iprovider = findInformationProvider(taggingForm) ;
      FolksonomyService folksonomyService = 
        (FolksonomyService)PortalContainer.getComponent(FolksonomyService.class) ;
      Node node = taggingForm.getDocumentNode() ;
      try {
        folksonomyService.addTag(node,tagNames) ;
        iprovider.addMessage(
            new ExoFacesMessage(FacesMessage.SEVERITY_INFO,res.getString("UITaggingForm.msg.tagging-successfully"))) ;
      }catch (Exception e) {
        iprovider.addMessage(
            new ExoFacesMessage(FacesMessage.SEVERITY_ERROR,res.getString("UITaggingForm.msg.tagging-unsuccessfully"))) ;
        //e.printStackTrace() ;
      }           
      taggingForm.reset() ;
      ((UILinkedTags)taggingForm.getSibling(UILinkedTags.class)).updateLinkedTags() ;
    }    
  }     
}
