/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr;

import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.fortuna.ical4j.data.CalendarOutputter;
import net.fortuna.ical4j.model.Calendar;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.cms.icalendar.ICalendarService;
/**
 * Created by The eXo Platform SARL        .
 * Mon, 30, 10, 2006 
 * @author: Hung Nguyen Quang
 * @email: nguyenkequanghung@yahoo.com
 */
public class ICalendarServlet extends HttpServlet {
  public void init(ServletConfig config) throws ServletException {}  
	public void service(HttpServletRequest request, HttpServletResponse response) 
          throws ServletException, IOException {
    response.setHeader("Cache-Control", "private max-age=600, s-maxage=120");
    String pathInfo = request.getPathInfo() ;
    pathInfo = pathInfo.substring(pathInfo.indexOf("/") + 1) ;
    String portalName = pathInfo.substring(0, pathInfo.indexOf("/")) ;
    String category = pathInfo.substring(pathInfo.indexOf("/") + 1) ;
    try{
      PortalContainer pcontainer = getPortalContainer(portalName) ;
      PortalContainer.setInstance(pcontainer) ;
      ICalendarService iCalService = 
        (ICalendarService)pcontainer.getComponentInstanceOfType(ICalendarService.class) ;
      Object obj = iCalService.generateICalendar(category) ;
      if(obj != null) {
        Calendar cal = (Calendar)obj ;
        response.setContentType("text/calendar");
        CalendarOutputter output = new CalendarOutputter();
        output.output(cal, response.getOutputStream());        
      }      
    }catch(Exception e) {
      e.printStackTrace() ;
      throw new ServletException(e) ;
    }    		
	} 
  
  private  PortalContainer getPortalContainer(String portalName) {
    PortalContainer pcontainer =  RootContainer.getInstance().getPortalContainer(portalName) ;
    return pcontainer ;
  }
}
