package org.exoplatform.portlets.content.jcr.component;

import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.Node;
import javax.jcr.Property;
import javax.jcr.PropertyIterator;
import javax.jcr.Session;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;
import org.exoplatform.services.cms.relations.RelationsService;


public class UIRenameForm extends UISimpleForm implements ChangeNodeListener{
  
  private UIStringInput newNameInput_ ;
  private UIStringInput oldName_ ;
  private Node renameNode_ ;  
  private Node curNode_ ;
  private UIJCRExplorer uiExplorer_ ;
  private RelationsService relationsService_ ;
  private boolean isReferencedNode_ = false;
  
  public UIRenameForm(RelationsService relationsService) {
    super("renameForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");
    relationsService_ = relationsService ;
    oldName_ = new UIStringInput("oldName","") ;
    newNameInput_ = new UIStringInput("newName","") ;
    add(newNameInput_) ;
    oldName_.setEditable(false) ;
    add(oldName_) ; 
    addActionListener(SaveNewNodeActionListener.class,SAVE_ACTION) ;
    addActionListener(CancelActionListener.class,CANCEL_ACTION) ;
  }
  
  public void update(Node renameNode, boolean isReferencedNode) throws Exception{
    isReferencedNode_ = isReferencedNode ;
    renameNode_ = renameNode ;   
    oldName_.setValue(renameNode.getName()) ; 
    newNameInput_.setValue("") ;
  }
   
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    setRendered(false) ;
    uiExplorer_ = uiExplorer ;
    curNode_ = node ;
  }
  
  static public class SaveNewNodeActionListener extends ExoActionListener {       
    public void execute(ExoActionEvent event) throws Exception { 
      UIRenameForm renameForm = (UIRenameForm)event.getSource() ;
      Information iprovider = findInformationProvider(renameForm) ;
      String oldName = renameForm.renameNode_.getName() ;
      List<Node> refList = new ArrayList<Node>() ;
      boolean isReference = false ;
      PropertyIterator references = null;
      try {        
        try{
          references = renameForm.renameNode_.getReferences() ;
          isReference = true ;
        }catch(Exception e){
          isReference = false ;
        }        
        if(isReference && references != null){
          if(references.getSize() > 0 ){
            while(references.hasNext()){
              Property pro = references.nextProperty() ;
              Node refNode = pro.getParent() ;
              renameForm.relationsService_.removeRelation(refNode, renameForm.renameNode_.getPath()) ;
              refNode.save() ;
              refList.add(refNode) ;
            }
          }
        }
        String newName = renameForm.newNameInput_.getValue() ;      
        String srcPath = renameForm.renameNode_.getPath() ;
        String destPath ; 
        if(renameForm.isReferencedNode_) {
          Node parent = renameForm.renameNode_.getParent() ;
          if(parent.getPath().equals("/"))
            destPath = "/" + newName ;
          else
            destPath = parent.getPath() + "/" + newName ;          
        }else {
          if(renameForm.curNode_.getPath().equals("/"))          
            destPath = "/" + newName ;
          else
            destPath = renameForm.curNode_.getPath() + "/" + newName ;
        }
        Session nodeSession = renameForm.renameNode_.getSession() ;
        nodeSession.move(srcPath, destPath) ;
        nodeSession.save() ;
        nodeSession.refresh(false) ;
        for(int i = 0; i < refList.size(); i ++){
          Node addRef = refList.get(i) ;
          renameForm.relationsService_.addRelation(addRef, destPath) ;
          addRef.save() ;
        }        
        renameForm.uiExplorer_.refreshSession() ;
        ResourceBundle res = getApplicationResourceBundle() ;
        Object[] args = {oldName, newName} ;
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_INFO,res.getString("UIRenameForm.msg.rename-successfull"),args)) ;
        renameForm.setRenderedSibling(UIDocumentInfo.class) ;
      }catch (Exception e) {
       JCRExceptionManager.process(iprovider,e) ;               
      }      
    }        
  }  
  
}
 