package org.exoplatform.portlets.content.jcr.component;

import java.util.ArrayList;
import java.util.List;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.jcr.Node;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;

public class UISelectViewForm extends UISimpleForm implements ChangeNodeListener {

  protected Node node_;
  private List<SelectItem> options = new ArrayList<SelectItem>();
  private  UISelectBox views_ ;
  
  public UISelectViewForm() throws Exception {
    super("UISelectViewForm", "post", null);
    setId("UISelectViewForm") ;
    setRendererType("SimpleFormVelocityRenderer");
    views_ = new UISelectBox("views","",options) ;
    add(views_) ;        
    addActionListener(SaveActionListener.class, SAVE_ACTION);
  }
  
  public void refresh(){
    ExternalContext eContext = FacesContext.getCurrentInstance().getExternalContext();
    PortletRequest request = (PortletRequest) eContext.getRequest();    
    PortletPreferences prefs_ = request.getPreferences();
    String views = prefs_.getValue("views", "") ;
    options = new ArrayList<SelectItem>();
    String[] array = views.split(",") ;
    for(int i = 0; i < array.length; i ++) {
      options.add(new SelectItem(array[i].trim(), array[i].trim())) ;
    }
    views_.setOptions(options) ;
    String currentView = views_.getValue() ;
    if(currentView == null || currentView.length() == 0)
      views_.setValue(array[0].trim()) ;        
  }
    
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    node_ = node;
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UISelectViewForm uicomp = (UISelectViewForm) event.getSource();
      UIJCRExplorer uiExplorer = (UIJCRExplorer) uicomp.getAncestorOfType(UIJCRExplorer.class);
      String view = uicomp.getUISelectBox("views").getValue() ;
      Information iprovider = findInformationProvider(uicomp);
      try {
        UIViewController viewController = (UIViewController)uicomp.getSibling(UIViewController.class) ;
        viewController.renderTabs(view) ;
        uiExplorer.broadcastOnChange(uicomp.node_);
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider, e);
      }
    }
  }
}
