/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.metadata.component;

import javax.jcr.nodetype.NodeType;

import org.exoplatform.faces.cms.CMSUtils;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.jcr.core.ExtendedPropertyType;
/**
 * @email:   nguyenkequanghung@yahoo.com
 * @version: $Id: UIContentDisplayer.java,v 1.2 2006/04/04
 */
public class UIMetadataView extends UIExoCommand {  

  private NodeType metadataType_  ;
  static Parameter [] BACK_PARAMS = { new Parameter(ACTION , BACK_ACTION) } ;  
  
  public UIMetadataView() {
    setRendererType("VelocityRenderer") ;    
    addActionListener(BackActionListener.class, BACK_ACTION) ;      
  }
  
  public Parameter[] getBackParams(){ return BACK_PARAMS ; } 
  public void  setMetadata(NodeType nodetype) { metadataType_ = nodetype ; }
  public NodeType getMetadata() { return metadataType_ ; }
  
  public String resolveType(int type) {
    return ExtendedPropertyType.nameFromValue(type);
  }
  
  public String getIcon(String propertyName) {        
    return CMSUtils.getPropertyIconByName(propertyName) ;
  }
  
  public String getIconByNodeTypeName(String nodeTypeName) {        
    return CMSUtils.getIconByNodeTypeName(nodeTypeName) ;
  }
  
  static public class BackActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMetadataView uiView = (UIMetadataView) event.getSource();
      uiView.setRenderedSibling(UIMetadataManager.class) ;
    }
  }
}