package org.exoplatform.portlets.content.nodetypes.component;

import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.nodetype.NodeDefinition;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.NameValidator;
import org.exoplatform.portal.Information;
import org.exoplatform.services.jcr.core.nodetype.NodeDefinitionValue;

public class UIChildNodeDefinitionForm extends UISimpleForm {
  private static String SELECT_REQUIREDTYPES_ACTION = "selectRequiredTypes" ;
  private static String SELECT_DEFAULTTYPES_ACTION = "selectDefaultTypes" ;
  public static Parameter[] SELECT_REQUIREDTYPES_PARAMS = { new Parameter(ACTION , SELECT_REQUIREDTYPES_ACTION)} ;
  public static Parameter[] SELECT_DEFAULTTYPES_PARAMS = { new Parameter(ACTION , SELECT_DEFAULTTYPES_ACTION)} ;
  private boolean isView_ = false;
  private NodeTypeManager ntManager_ ;
  public UIChildNodeDefinitionForm() {
    super("uiPropertyDefinitionForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");
    UISelectBox namespace = new UISelectBox("namespace","",new ArrayList()) ;
    UIStringInput childNodeName = new UIStringInput("childnodename", "") ;
    UIStringInput defaultPrimaryType = new UIStringInput("defaulttype", "") ;
    List<SelectItem> booleanItem = new ArrayList<SelectItem>();
    booleanItem.add(new SelectItem("true", "true")) ;
    booleanItem.add(new SelectItem("false", "false")) ;
    UISelectBox mandatory = new UISelectBox("mandatory", "false", booleanItem) ;
    UISelectBox autocreated = new UISelectBox("autocreated", "false", booleanItem) ;
    UISelectBox isprotected = new UISelectBox("protected", "false", booleanItem) ;
    UISelectBox isSameNameSibling = new UISelectBox("samenamesibling", "false", booleanItem) ;
    List<SelectItem> versionItem = new ArrayList<SelectItem>();
    versionItem.add(new SelectItem("COPY", "1")) ;
    versionItem.add(new SelectItem("VERSION", "2")) ;
    versionItem.add(new SelectItem("INITIALIZE", "3")) ;
    versionItem.add(new SelectItem("COMPUTE", "4")) ;
    versionItem.add(new SelectItem("IGNORE", "5")) ;
    versionItem.add(new SelectItem("ABORT", "6")) ;
    UISelectBox parentVersion = new UISelectBox("parentversion", "1", versionItem) ;
    UIStringInput requiredPrimaryType = new UIStringInput("requiredtype", "") ;
    childNodeName.addValidator(NameValidator.class) ;
    add(namespace) ;
    add(childNodeName) ;
    add(defaultPrimaryType) ;
    add(isSameNameSibling) ;
    add(mandatory) ;
    add(autocreated) ;
    add(isprotected) ;
    add(parentVersion) ;
    add(requiredPrimaryType) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
    addActionListener(SaveActionListener.class, SAVE_ACTION); 
    addActionListener(SelectRequiredTypesActionListener.class, SELECT_REQUIREDTYPES_ACTION);
    addActionListener(SelectDefaultTypesActionListener.class, SELECT_DEFAULTTYPES_ACTION);    
  }
  
  public String selectRequiredTypesParams() { return SELECT_REQUIREDTYPES_ACTION ;  }
  public String selectDefaultTypesParams() { return SELECT_DEFAULTTYPES_ACTION ;  }
  public boolean isView() { return isView_ ; }
  
  private void refresh() {
    getUIStringInput("childnodename").setValue("") ;
    getUIStringInput("defaulttype").setValue("") ;
    getUISelectBox("mandatory").setValue("false") ;
    getUISelectBox("autocreated").setValue("false") ;
    getUISelectBox("protected").setValue("false") ;
    getUISelectBox("samenamesibling").setValue("false") ;
    getUISelectBox("parentversion").setValue("1") ;
    getUIStringInput("requiredtype").setValue("") ;
    
    getUISelectBox("namespace").setEditable(true) ;
    getUIStringInput("childnodename").setEditable(true) ;
    getUIStringInput("defaulttype").setEditable(true) ;
    getUISelectBox("mandatory").setEditable(true) ;
    getUISelectBox("autocreated").setEditable(true) ;
    getUISelectBox("protected").setEditable(true) ;
    getUISelectBox("samenamesibling").setEditable(true) ;
    getUISelectBox("parentversion").setEditable(true) ;
    getUIStringInput("requiredtype").setEditable(true) ;
  }
  
  public void updateEdit(NodeDefinitionValue nodeDef, List prefixes) {
    getUISelectBox("namespace").setOptions(prefixes).setEditable(false) ;
    String[] name = nodeDef.getName().split(":") ;
    getUISelectBox("namespace").setValue(name[0]) ;
    getUIStringInput("childnodename").setValue(name[1]).setEditable(false) ;
    getUIStringInput("defaulttype").setValue(nodeDef.getDefaultNodeTypeName()).setEditable(true) ;
    getUISelectBox("mandatory").setValue(String.valueOf(nodeDef.isMandatory())).setEditable(true) ;
    getUISelectBox("autocreated").setValue(String.valueOf(nodeDef.isAutoCreate())).setEditable(true) ;
    getUISelectBox("protected").setEditable(true) ;
    getUISelectBox("samenamesibling").setValue(String.valueOf(nodeDef.isSameNameSiblings())).setEditable(true) ;
    getUISelectBox("parentversion").setValue(String.valueOf(nodeDef.getOnVersion())).setEditable(true) ;
    List requireNodeType = nodeDef.getRequiredNodeTypeNames() ;
    StringBuilder requireName = new StringBuilder() ;
    for(int i = 0; i < requireNodeType.size(); i ++) {
      if(requireName.length() > 0) requireName.append(",") ;
      requireName.append(requireNodeType.get(i).toString()) ;
    }
    getUIStringInput("requiredtype").setValue(requireName.toString()).setEditable(true) ;
    isView_ = false ;
  }
  
  public void update( NodeTypeManager ntManager, NodeType nodeType, String childNodeName, List namespaces, boolean isView){
    ntManager_ = ntManager ;
    getUISelectBox("namespace").setOptions(namespaces) ;
    if(childNodeName != null){
      NodeDefinition[] nodeDefinitions = nodeType.getChildNodeDefinitions() ;
      for(int i = 0; i < nodeDefinitions.length ; i++){
        String name = nodeDefinitions[i].getName();
        if(name.equals(childNodeName)) {
          if(childNodeName.indexOf(":") > -1) {
            getUISelectBox("namespace").setValue(childNodeName.substring(0, childNodeName.indexOf(":"))) ;
            getUIStringInput("childnodename").setValue(childNodeName.substring(childNodeName.indexOf(":") + 1)) ;
          }else {
            getUISelectBox("namespace").setValue("") ;
            getUIStringInput("childnodename").setValue(childNodeName) ;
          }
          NodeType defaultNodeType = nodeDefinitions[i].getDefaultPrimaryType() ; 
          if(defaultNodeType != null)
            getUIStringInput("defaulttype").setValue(defaultNodeType.getName()) ;          
          getUISelectBox("samenamesibling").setValue(
              String.valueOf(nodeDefinitions[i].allowsSameNameSiblings())) ;          
          getUISelectBox("mandatory").setValue(String.valueOf(nodeDefinitions[i].isMandatory())) ;          
          getUISelectBox("autocreated").setValue(String.valueOf(nodeDefinitions[i].isAutoCreated())) ;          
          getUISelectBox("protected").setValue(String.valueOf(nodeDefinitions[i].isProtected())) ;
          String parentVersion = Integer.toString(nodeDefinitions[i].getOnParentVersion()) ;
          getUISelectBox("parentversion").setValue(parentVersion) ;          
          StringBuffer requiredType = new StringBuffer() ; 
          NodeType[] requiredPrimaryType = nodeDefinitions[i].getRequiredPrimaryTypes() ;
          for(int j = 0; j < requiredPrimaryType.length; j ++){
            if(requiredType.length() > 0) requiredType.append(" , ") ;
            requiredType.append(requiredPrimaryType[j].getName()) ;
          }
          getUIStringInput("requiredtype").setValue(requiredType.toString()) ;
          break ;
        }
      }
      if(isView){
        getUISelectBox("namespace").setEditable(false) ;
        getUIStringInput("childnodename").setEditable(false) ;
        getUIStringInput("defaulttype").setEditable(false) ;
        getUISelectBox("samenamesibling").setEditable(false) ;          
        getUISelectBox("mandatory").setEditable(false) ;          
        getUISelectBox("autocreated").setEditable(false) ;          
        getUISelectBox("protected").setEditable(false) ;
        getUISelectBox("parentversion").setEditable(false) ;
        getUIStringInput("requiredtype").setEditable(false) ;
      }
    }else {
      refresh() ;
    }
    isView_ = isView ;
  }
  
  public void setRequiredTypes( List requiredtypes) {
    StringBuffer types = new StringBuffer("") ;
    for(int i = 0; i < requiredtypes.size(); i ++) {
      if(types.length() > 0) 
        types.append(", ") ;
      types.append(requiredtypes.get(i)) ;
    }
    getUIStringInput("requiredtype").setValue(types.toString()) ;
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIChildNodeDefinitionForm uiForm = (UIChildNodeDefinitionForm) event.getSource();
      ResourceBundle res = getApplicationResourceBundle() ;
      Information iprovider = findInformationProvider(uiForm);
      NodeDefinitionValue nodeTypeValue = new NodeDefinitionValue();
      String childNodeName ;
      String prefix = uiForm.getUISelectBox("namespace").getValue() ;
      if(prefix != null && prefix.length() > 0)
        childNodeName = prefix + ":" + uiForm.getUIStringInput("childnodename").getValue() ;
      else
        childNodeName = uiForm.getUIStringInput("childnodename").getValue() ;
      if(childNodeName == null || childNodeName.length() == 0) {
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR ,
            res.getString("UIChildNodeDefinitionForm.msg.child-name"))) ;
        return ;
      }
      nodeTypeValue.setName(childNodeName) ;
      String defaultType = uiForm.getUIStringInput("defaulttype").getValue() ;
      nodeTypeValue.setDefaultNodeTypeName(defaultType) ;
      nodeTypeValue.setSameNameSiblings(
          Boolean.parseBoolean(uiForm.getUISelectBox("samenamesibling").getValue())) ;      
      nodeTypeValue.setMandatory(Boolean.parseBoolean(uiForm.getUISelectBox("mandatory").getValue())) ;      
      nodeTypeValue.setAutoCreate(Boolean.parseBoolean(uiForm.getUISelectBox("autocreated").getValue())) ;
      int parentVer = Integer.parseInt(uiForm.getUISelectBox("parentversion").getValue()) ;
        nodeTypeValue.setOnVersion(parentVer) ;
      String requiredType = uiForm.getUIStringInput("requiredtype").getValue() ;
      String[] types = requiredType.split(",") ;
      List<String> reqList = new ArrayList<String>() ;
      for(int i = 0; i < types.length; i++){
        reqList.add(types[i].trim()) ;
      }
      nodeTypeValue.setRequiredNodeTypeNames(reqList) ;
      UINodeTypeForm nodeTypeForm = (UINodeTypeForm)uiForm.getSibling(UINodeTypeForm.class) ;
      nodeTypeForm.addNewChildNodeDefinition(nodeTypeValue) ;
      uiForm.setRenderedSibling(UINodeTypeForm.class) ;
    }
  }

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIChildNodeDefinitionForm uiForm = (UIChildNodeDefinitionForm) event.getSource();
      uiForm.setRenderedSibling(UINodeTypeForm.class) ;
    }
  }
  
  static public class SelectRequiredTypesActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIChildNodeDefinitionForm uiForm = (UIChildNodeDefinitionForm) event.getSource();
      String requiredTypes = uiForm.getUIStringInput("requiredtype").getValue() ;
      List<String> types = new ArrayList<String>() ;
      if(requiredTypes != null && requiredTypes.length() > 0) {
        if(requiredTypes.indexOf(",") > -1) {
          String[] array = requiredTypes.split(",") ;
          for(int i = 0; i < array.length; i ++){
            types.add(array[i].trim()) ;
          }
        }else{
          types.add(requiredTypes.trim()) ;
        }
      }
      UIOptionList optionList = (UIOptionList)uiForm.getSibling(UIOptionList.class) ;
      optionList.update(uiForm.ntManager_, types, "requiredTypes") ;
      uiForm.setRenderedSibling(UIOptionList.class) ;
    }
  }
  
  static public class SelectDefaultTypesActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIChildNodeDefinitionForm uiForm = (UIChildNodeDefinitionForm) event.getSource();
      List types = new ArrayList() ;
      UIOptionList optionList = (UIOptionList)uiForm.getSibling(UIOptionList.class) ;
      optionList.update(uiForm.ntManager_, types, "defaultTypes") ;
      uiForm.setRenderedSibling(UIOptionList.class) ;
    }
  }
  
}
