package org.exoplatform.portlets.content.nodetypes.component;

import java.io.ByteArrayInputStream;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.nodetype.NodeTypeManager;

import org.exoplatform.commons.utils.MimeTypeResolver;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISimpleMulltipartForm;
import org.exoplatform.faces.core.component.UIUploadInput;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.services.jcr.core.nodetype.NodeTypeValuesList;
import org.jibx.runtime.BindingDirectory;
import org.jibx.runtime.IBindingFactory;
import org.jibx.runtime.IUnmarshallingContext;

public class UINodeTypeUpload extends UISimpleMulltipartForm {
  
  protected NodeTypeManager ntManager_ ;
  private static String UPLOAD_ACTION = "import" ;
  
  public static Parameter[] UPLOAD_PARAMS = { new Parameter(ACTION , UPLOAD_ACTION)} ;
  
  public UINodeTypeUpload() {
    super("uiNodeTypeUpload", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;
    UIUploadInput fileUpload = new UIUploadInput("upload") ;
    add(fileUpload) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
    addActionListener(UploadActionListener.class, UPLOAD_ACTION) ;
  }
  
  public String getUploadParams() { return UPLOAD_ACTION ;  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINodeTypeUpload uiForm = (UINodeTypeUpload) event.getSource() ;
      uiForm.setRenderedSibling(UINodeTypeList.class) ;
    }
  }
  public void update(NodeTypeManager ntManager) {
    ntManager_ = ntManager ;
  }
  static public class UploadActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINodeTypeUpload uiForm = (UINodeTypeUpload) event.getComponent() ;
      ResourceBundle res = getApplicationResourceBundle() ;
      Information iprovider = findInformationProvider(uiForm);
      UIUploadInput input = (UIUploadInput)uiForm.getUIInput("upload") ;
      String fileName = input.getFileName() ;
      if(fileName == null || fileName.length() == 0) {
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR,
            res.getString("UINodeTypeUpload.msg.filename-error"))) ;
        return ;
      }
      MimeTypeResolver resolver = new MimeTypeResolver();
      String mimeType = resolver.getMimeType(fileName);
      if( !mimeType.trim().equals( "text/xml")){        
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR,
            res.getString("UINodeTypeUpload.msg.data-file-error"))) ;
        return;      
      }
      ByteArrayInputStream is = new ByteArrayInputStream(input.getContent()) ;
      try {
        IBindingFactory factory = BindingDirectory.getFactory(NodeTypeValuesList.class);
        IUnmarshallingContext uctx = factory.createUnmarshallingContext();
        NodeTypeValuesList nodeTypeValuesList = (NodeTypeValuesList) uctx
            .unmarshalDocument(is, null);
        List ntvList = nodeTypeValuesList.getNodeTypeValuesList();
        UINodeTypeImport uiImport = (UINodeTypeImport)uiForm.getSibling(UINodeTypeImport.class) ;
        uiImport.update(ntvList, uiForm.ntManager_) ;        
      } catch (Exception e) {
        e.printStackTrace();
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR,
                             res.getString("UINodeTypeUpload.msg.data-invalid"))) ;
        return ;
      }
      uiForm.setRenderedSibling(UINodeTypeImport.class) ;
    }
    
  }
}
