package org.exoplatform.portlets.content.nodetypes.component;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeIterator;
import javax.jcr.nodetype.NodeTypeManager;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.cms.CMSUtils;
import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.nodetypes.component.UINodeTypeList.NodeTypeNameComparator;

public class UIOptionList extends UISimpleForm {
  
  protected NodeTypeManager ntManager_ ;
  private List<NodeType> nodeTypeList_ = new ArrayList<NodeType>() ;
  private String fieldReturn_ ;
  public UIOptionList() {
    super("uiOptionList", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;
    
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
  }
  
  public void update(NodeTypeManager ntManager, List seletedList, String fieldReturn) throws Exception{
    NodeTypeIterator ntIterator = ntManager.getAllNodeTypes() ;
    fieldReturn_ = fieldReturn ;
    nodeTypeList_ = new ArrayList<NodeType>() ;
    while(ntIterator.hasNext()){
      NodeType nodeType = ntIterator.nextNodeType() ;
      nodeTypeList_.add(nodeType) ;
      UICheckBox checkbox = new UICheckBox(nodeType.getName(), "") ;
      if(seletedList != null && seletedList.size() > 0){
        for(int i = 0 ; i < seletedList.size() ; i ++){
          if(nodeType.getName().equals(seletedList.get(i))){
            checkbox.setSelect(true) ;
            break ;
          } 
        }
      }
      add(checkbox) ;
    }
    Collections.sort(nodeTypeList_, new NodeTypeNameComparator()) ;
  }
  
  public List getNodeTypes() {
    return nodeTypeList_ ;
  }
  
  public String getIcon(String nodeType) {
    return CMSUtils.getIconByNodeTypeName(nodeType) ;
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIOptionList uiForm = (UIOptionList) event.getSource() ;
      if( uiForm.fieldReturn_.equals("supertypes")) 
        uiForm.setRenderedSibling(UINodeTypeForm.class) ;
      else
        uiForm.setRenderedSibling(UIChildNodeDefinitionForm.class) ;      
    }
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIOptionList uiForm = (UIOptionList) event.getSource() ;
      List<String> selectedNodes = new ArrayList<String>() ;
      for(int i = 0 ; i < uiForm.nodeTypeList_.size(); i ++){
        NodeType nodeType = uiForm.nodeTypeList_.get(i) ;
        boolean checked = uiForm.getUICheckBox(nodeType.getName()).getSelect() ;
        if(checked) selectedNodes.add(nodeType.getName()) ;
      }      
      if( selectedNodes.size() == 0 ) {
        
      }
      if(uiForm.fieldReturn_.equals("supertypes")) {
        UINodeTypeForm nodeTypeForm = (UINodeTypeForm)uiForm.getSibling(UINodeTypeForm.class) ;
        nodeTypeForm.setSuperTypes(selectedNodes) ;
        uiForm.setRenderedSibling(UINodeTypeForm.class) ;
      }else if(uiForm.fieldReturn_.equals("requiredTypes")){
        UIChildNodeDefinitionForm childNodeForm = 
          (UIChildNodeDefinitionForm)uiForm.getSibling(UIChildNodeDefinitionForm.class) ;
        childNodeForm.setRequiredTypes(selectedNodes) ;
        uiForm.setRenderedSibling(UIChildNodeDefinitionForm.class) ;
      }else {
        if(selectedNodes.size() > 1) {
          Information iprovider = findInformationProvider(uiForm);
          ResourceBundle res = getApplicationResourceBundle() ;
          iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR ,
            res.getString("UIOptionList.msg.values-error"))) ;
          return;
        }
        UIChildNodeDefinitionForm childNodeForm = 
          (UIChildNodeDefinitionForm)uiForm.getSibling(UIChildNodeDefinitionForm.class) ;
        if(selectedNodes.size() > 0)
          childNodeForm.getUIStringInput("defaulttype").setValue(selectedNodes.get(0).toString()) ;
        uiForm.setRenderedSibling(UIChildNodeDefinitionForm.class) ;
      }      
    }    
  }
}
