package org.exoplatform.portlets.content.nodetypes.component;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.faces.core.component.UIInput;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

public class UIValueConstraintsForm extends UISimpleForm {
  private List values_ ;
  public UIValueConstraintsForm() {
    super("uiValueConstraintsForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;  
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
  }
  
  public void update(List value) {
    UIStringInput values = new UIStringInput("values", "") ;
    add(values) ;
    if(value.size() > 0) {
      values_ = value ;
    }else {
      values_ = new ArrayList() ;
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIValueConstraintsForm uiForm = (UIValueConstraintsForm) event.getSource() ;
      uiForm.setRenderedSibling(UIPropertyDefinitionForm.class) ;
    }
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIValueConstraintsForm uiForm = (UIValueConstraintsForm) event.getSource() ;
      List values = uiForm.getMultipleValuesUIInput("values") ;
      for(int i = 0; i < values.size(); i++) {
        UIInput value = (UIInput)values.get(i) ;
        if(!uiForm.values_.contains(value.getValue()))
          uiForm.values_.add(value.getValue()) ;          
      }
      UIPropertyDefinitionForm property = 
        (UIPropertyDefinitionForm)uiForm.getSibling(UIPropertyDefinitionForm.class) ;
      property.setAddedConstraints(uiForm.values_) ;            
      uiForm.setRenderedSibling(UIPropertyDefinitionForm.class) ;
    }
    
  }
}
