package org.exoplatform.portlets.content.taxonomy.component;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.NodeIterator;
import javax.jcr.PathNotFoundException;
import javax.jcr.RepositoryException;

public class TaxonomyNode {
	private boolean isExpanded = true;
	private Node node_;
	private List<TaxonomyNode> children_ = new ArrayList<TaxonomyNode>();
	
	public TaxonomyNode(Node node) throws RepositoryException {
		node_ = node;
		try {
			NodeIterator iter = node_.getNodes() ;
			if(iter.getSize()==0) { isExpanded = false; }
			while(iter.hasNext()) {
				Node child = iter.nextNode() ;
				children_.add(new TaxonomyNode(child)) ;
			}						     
		} catch (PathNotFoundException e) {
		}		
	}	
	
	public boolean isExpanded() { return isExpanded; }	
	public void setExpanded(boolean isExpanded) { this.isExpanded = isExpanded; }
  
	public Node getNode() { return node_ ; }	
	public void setNode(Node node) { this.node_ = node ; }
	
	public String getName() throws RepositoryException { return node_.getName(); }
	
	public String getPath() throws RepositoryException { return node_.getPath(); }
	
  public int getChildrenSize() { return children_.size(); }
  public List<TaxonomyNode> getChildren() { return children_; }	
	
	public TaxonomyNode findTaxonomyNode(String path) throws RepositoryException {
		if(node_.getPath().equals(path))
			return this;
		TaxonomyNode tnode = null;
		for (Iterator iter = children_.iterator(); iter.hasNext();) {
			TaxonomyNode child = (TaxonomyNode) iter.next();
			tnode = child.findTaxonomyNode(path);
			if(tnode != null)
				return tnode;
		}
		return null;
	}
	
}
