/*
 * Created on Apr 8, 2005
 */
package org.exoplatform.portlets.content.templates.component;

import java.util.Iterator;
import java.util.List;

import javax.faces.component.UIComponent;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * @author benjaminmestrallet
 */
public class UIListsManager extends UIExoCommand {
  
  static Parameter[] BACK_PARAMS = { new Parameter(ACTION, BACK_ACTION) };
  
  protected String nodeType;  
  
  public UIListsManager() throws Exception {
    setId("UIListsManager");
    setRendererType("VelocityRenderer");    
    
    UITemplatesList dialogs = (UITemplatesList) addChild(UITemplatesList.class);
    dialogs.setId("DialogList");    
    dialogs.setDialog(true);    
    
    UITemplatesList views = (UITemplatesList) addChild(UITemplatesList.class);
    views.setId("ViewList");        
    views.setDialog(false);    
    
    addActionListener(BackActionListener.class, BACK_ACTION);
  }
  
  public Parameter[] getBackParams() { return BACK_PARAMS; }
  
  public void setNodeType(String nodeType) {
    this.nodeType = nodeType;
    List children = getChildren();
    for (Iterator iter = children.iterator(); iter.hasNext();) {
      UIComponent component = (UIComponent) iter.next();
      if(component instanceof UITemplatesList)
        ((UITemplatesList)component).setNodeType(nodeType);
    }
  }
    
  static public class BackActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIListsManager uicomp = (UIListsManager) event.getComponent();
      uicomp.setRenderedSibling(UINodeTypesList.class);
    }
  }
  
}