package org.exoplatform.portlets.content.views.component;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cms.views.ManageViewService;

public class UIRemoveTabForm extends UISimpleForm {
  
  private String viewName_ ;
  private List tabs_ = new ArrayList() ;
  private ManageViewService vservice_ ;
  public UIRemoveTabForm(ManageViewService vservice) {    
    super("uiRemoveTabForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");
    vservice_ = vservice ;
    UIStringInput viewname = new UIStringInput("viewname","") ;
    viewname.setEditable(false) ;
    add(viewname) ;
    
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
    addActionListener(SaveActionListener.class, SAVE_ACTION);
  }
  
  public void update(String viewName, List tabs) throws Exception{
    getUIStringInput("viewname").setValue(viewName) ;
    for(int i = 0 ; i < tabs.size() ; i ++){
      Node tab = (Node)tabs.get(i) ;
      UICheckBox checkbox = new UICheckBox(tab.getName(), "") ;
      checkbox.setSelect(true) ;
      add(checkbox) ;
    }
    viewName_ = viewName ;
    tabs_ = tabs ;
  }
  
  public List getAllTabs(){ return tabs_ ; }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {      
      UIRemoveTabForm uiForm = (UIRemoveTabForm)event.getSource() ;
      List<String> removedTabs = new ArrayList<String>() ;
      for(int i = 0 ; i < uiForm.tabs_.size() ; i ++) {
        Node tab = (Node)uiForm.tabs_.get(i) ;
        String tabName = tab.getName().trim() ;
        if(!uiForm.getUICheckBox(tabName).getSelect())
          removedTabs.add(tabName) ;
      }            
      UIViewFormController viewFormController = (UIViewFormController)uiForm.getSibling(UIViewFormController.class) ;      
      Node view = uiForm.vservice_.getViewHome().getNode(uiForm.viewName_) ;
      if(removedTabs.size() > 0){        
        for(int i = 0 ; i < removedTabs.size() ; i ++ ){                            
          Node tab = view.getNode(removedTabs.get(i).toString()) ;
          tab.remove() ;               
        }                     
      }          
      view.getSession().save();      
      viewFormController.showEditViewForm(view, false);
      uiForm.setRenderedSibling(UIViewFormController.class) ;
    }
  }

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIRemoveTabForm uiForm = (UIRemoveTabForm)event.getSource() ;
      uiForm.setRenderedSibling(UIViewFormController.class) ;
    }
  }
}
