/*
 * Copyright 2001-2006 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.portlets.jcrconsole;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.frameworks.jcr.cli.CliAppContext;
import org.apache.commons.chain.Catalog;
import org.apache.commons.chain.Command;
import org.exoplatform.container.ExoContainer;
import org.exoplatform.container.ExoContainerContext;
import org.exoplatform.services.command.impl.CommandService;

import org.exoplatform.services.jcr.RepositoryService;

import javax.jcr.Credentials;
import javax.jcr.SimpleCredentials;



public class JcrConsoleServlet extends HttpServlet {

 
  private CliAppContext context;
  private ArrayList<String> params = new ArrayList<String>();
  private final static String  PARAMETERS_KEY = "paramethers";

  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
    
    response.setContentType("text/html");
    PrintWriter w = response.getWriter();

    try {
      String containerName = request.getParameter("context").trim();
      ExoContainer container = ExoContainerContext
          .getContainerByName(containerName);

      String commandLine = request.getParameter("myaction").trim();

      String command = commandLine.substring(0,
          (commandLine.indexOf(" ") < 0) ? commandLine.length() : commandLine.indexOf(" "));

      commandLine = commandLine.substring(commandLine.indexOf(command)+ command.length());
      commandLine = commandLine.trim();

      if (context == null){
      Credentials cred = new SimpleCredentials("exoadmin", "exo@ecm".toCharArray());  
      RepositoryService repService = (RepositoryService) container.getComponentInstanceOfType(RepositoryService.class);
      context = new CliAppContext(repService.getRepository(),PARAMETERS_KEY, cred);
      context.setCurrentItem(context.getSession().getRootNode());
      }
      
      CommandService cservice = (CommandService)container.getComponentInstanceOfType(CommandService.class);
      Catalog c = cservice.getCatalog("CLI");

      Command comm = c.getCommand(command);
      
      params = parseQuery(commandLine);
      context.put(PARAMETERS_KEY, params);
      comm.execute(context);

      w.print(context.getOutput());
      
    } catch (Exception e) {
      //e.printStackTrace();
      System.out.println("[ERROR] [jcr-concole] Can't execute command - " + e.getMessage());
      w.print("Invalid command\n");
    }
    
  }

   private ArrayList parseQuery(String query) {
    int i = 0;

    try {
      params.clear();
      if (query.indexOf("\"") == -1) {
        while (!query.equals("")) {
          String item = query.substring(0, (query.indexOf(" ") < 0) ? query
              .length() : query.indexOf(" "));

          params.add(item);
          query = query.substring(query.indexOf(item) + item.length());
          query = query.trim();
          i++;
        }
      } else {

        while (!query.equals("")) {
          String item = "";
          if (query.startsWith("\"")) {
            item = query.substring(query.indexOf("\""),
                (query.indexOf("\"", 1) < 0) ? query.length() : query.indexOf(
                    "\"", 1) + 1);
          } else {
            item = query.substring(0, (query.indexOf(" ") < 0) ? query.length()
                : query.indexOf(" "));
          }
          item = item.trim();
          if (item != null && item != "") {
            params.add(item);
          }
          query = query.substring(query.indexOf(item) + item.length());
          query = query.trim();
          i++;
        }
      }

    } catch (Exception e) {
      e.printStackTrace();
      
    }
    return params;
  }

}
