/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: Digest.java 8508 2006-09-03 20:38:40Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.services.signer;

import static java.lang.System.out;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * @version $Rev: 8508 $ $Date: 2006-09-04 03:38:40 +0700 (Mon, 04 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class Digest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		out.println("eXo Digest program ($Rev: 8508 $).");
		out.println();

		if (args.length != 2) {
			out.println("Usage:");
			out.println("  java Digest <algorithm> <value>");
			System.exit(1);
		}

		String algorithm = args[0];
		String value = args[1];

		MessageDigest md = null;
		try {
	        md = MessageDigest.getInstance(algorithm);
        } catch (NoSuchAlgorithmException e) {
	        out.println("No such algorithm: " + algorithm);
			System.exit(-1);
        }

        md.update(value.getBytes());
        byte[] digest = md.digest();

        // print the result
        out.println(algorithm + " (\"" + value + "\") = " +
        		byteArrayToHexString(digest));

        // exit normally
        System.exit(0);
	}

	public static String byteArrayToHexString(byte[] hashValue) {
		return byteArrayToHexString(hashValue, null);
	}

	public static String byteArrayToHexString(byte[] hashValue, String step) {
    
    	StringBuffer hexDigest = new StringBuffer();
    
    	for (byte octet : hashValue) {
    		if (hexDigest.length() > 0 && step != null) hexDigest.append(step);
    		hexDigest.append(Integer.toHexString(octet & 0xff));
    	}
    
    	return hexDigest.toString();
    }

}
