package org.exoplatform.services.workflow.impl.oncepi;

import java.util.Date;

public class WorkflowServiceContainerHelper {
	
	 public static final Object stringToObject(String value, String component) {
		    
		    Object ret = null;
		    
		    if("date".equals(component) || "datetime".equals(component)) {
		      if(value == null || "".equals(value)) {
		        // The value is unset, use the current date
		        ret = new Date();
		      }
		      else {
		        // The value is assumed to be a long
		        ret = new Date(Long.parseLong(value));
		      }
		    }
		    else {
		      if(value == null) {
		        // Increase robustness by creating an empty String
		        ret = "";
		      }
		      else {
		        // By default the returned Object is the specified String
		        ret = value;
		      }
		    }
		    
		    return ret;
		  }
	 
	 public static final String objectToString(Object value, String component) {

		    String ret = null;
		    
		    if(value == null) {
		      // Increase robustness
		      ret = "";
		    }
		    else if("date".equals(component) || "datetime".equals(component)) {
		      /*
		       * The value is assumed to be a Date. Convert it to a long that represents
		       * the number of milliseconds since January 1, 1970. That way human
		       * readable representations are not used, which avoids Localization
		       * issues.
		       */
		      ret = new Long(((Date) value).getTime()).toString();
		    }
		    else {
		      // Delegate to the default Java conversion method
		      ret = value.toString();
		    }
		    
		    return ret;
		  }
}
